/*
 * GluonJ, An Aspect-Oriented Programming System for Java.
 * Copyright (C) 2006 Shigeru Chiba. All Rights Reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License.  Alternatively, the contents of this file may be used under
 * the terms of the GNU Lesser General Public License Version 2.1 or later.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 */
package javassist.gluonj;

import javassist.gluonj.weave.AliasList;


public class AliasedPcExpr {
    private AliasList aliases;

    AliasedPcExpr(String alias, String expr) {
        aliases = new AliasList(alias, expr);
    }

    public AliasedPcExpr define(String aliasName, String expr) {
        AliasList a = new AliasList(aliasName, expr);
        aliases = AliasList.concat(aliases, a);
        return this;
    }

    public Pointcut expr(Pointcut pc) {
        return Pcd.expr(pc).setAlias(aliases);
    }

    public Pointcut within(String className) {
        return Pcd.within(className).setAlias(aliases);
    }

    public Pointcut call(String methodName) {
        return Pcd.call(methodName).setAlias(aliases);
    }

    public Pointcut set(String fieldName) {
        return Pcd.set(fieldName).setAlias(aliases);
    }

    public Pointcut get(String fieldName) {
        return Pcd.get(fieldName).setAlias(aliases);
    }
}
