/*
 * GluonJ, An Aspect-Oriented Programming System for Java.
 * Copyright (C) 2006 Shigeru Chiba. All Rights Reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License.  Alternatively, the contents of this file may be used under
 * the terms of the GNU Lesser General Public License Version 2.1 or later.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 */
package javassist.gluonj.pc;

import javassist.gluonj.WeaveException;

public class SetPc extends AccessPc {
    public SetPc(String field) {
        super(field);
    }

    public String toString() {
        return "set(" + patternStr + ")";
    }

    public void prepare(Parser p) throws WeaveException {
        super.prepare(p);
        if (!pattern.isField())
            throw new WeaveException("bad pattern: " + toString());
    }

    public void accept(PointcutVisitor v) throws WeaveException {
        v.visit(this);
    }
}
